-- Platform Scrolling Test (ImageData)
function love.load()
  love.keyboard.setKeyRepeat(10, 1) --https://love2d.org/wiki/love.keyboard.setKeyRepeat

  local platformImageData = love.image.newImageData("foreground.png")
	platformImageWidth = platformImageData:getWidth()
	local platformImageHeight = platformImageData:getHeight()
  local windowWidth = love.graphics.getWidth()
  
  platform = {}
  speed = 1000
  x = 0
  xMax = platformImageWidth - windowWidth

  --generate images
  tPlatformImage = {}
  -- split full images in n parts and store 'em in a table. n = PlatformImageWidth/windowWidth
  for i = 1, math.ceil(platformImageWidth/windowWidth), 1 do
    local buffer = love.image.newImageData(windowWidth, platformImageHeight)
    buffer:paste(platformImageData, 0, 0, (i - 1)*windowWidth, 0)
    tPlatformImage[i] = love.graphics.newImage(buffer)
  end;
  
  --draw function, draw three images around the screen
  --draw: current image part, immediate previous part and immediate next part
  function drawPlatform(pX, pY)
   local currentPosition = math.floor(x/windowWidth) 
    local xModWidth = math.fmod(x, windowWidth)
    
	for i = 0, 2, 1 do
      if tPlatformImage[currentPosition + i] then
		--draw currentImage-1, currentImage and currentImage + 1 
      love.graphics.draw(tPlatformImage[currentPosition + i], pX + (i-1)*windowWidth - xModWidth, pY)
	  end
	  
    end
  end
end

function love.draw()
  drawPlatform(0, 526)
	love.graphics.print("FPS: "..love.timer.getFPS() .. '\nMem(kB): ' .. math.floor(collectgarbage("count")), 650, 20)
end

function love.keypressed(key)
  local dt = love.timer.getDelta()
  if key == "right" then
  
	if x >= 0 and x < xMax then
	 x = x + (speed * dt)
	else
	 x = xMax
	end

  elseif key == "left" then
    
	if x > 0 and x < platformImageWidth then
	 x = x - (speed * dt)
	else
	 x = 0
	end

  elseif key == "escape" then
    love.event.push("q")
  end
  
end
